<?php

namespace App\Controllers;

use CodeIgniter\HTTP\Response;
use Exception;

class Procedure extends BaseController
{

    function __construct()
    {
        $this->db = \Config\Database::connect();
    }

    public function index()
    {
        /*//echo ['Hola' => 'hola'];
        $res = $this->db->query("call test()")->getResultArray();
        //echo $res;
        header('Content-Type: application/json');
        echo json_encode(json_decode($res[0]['result']));*/

        $req = json_decode($this->request->getBody());

        $data = $req->data;
        $res = null;
        switch ($data->action) {
            case 'listar':
                $info = $this->getInfo($data->info, 1);
                $select = $info['select'];
                $where = $info['where'];
                $res1 = $this->call("procedList", "'$data->table'", "\"$select\", \"$where\"");
                $res = json_decode($res1[0]->result);
                $this->log();
                break;
            case 'insertar':
                $res = ['type' => gettype($data->info), "data" => $data->info];
                if (gettype($data->info) == 'array') {
                    foreach ($data->info as $value) {
                        if (isset($value->photo)) {
                            $value->photo = $this->createImage($value->photo, "images/$data->table/"); 
                        }
                        $info = $this->getInfo($value, 2);
                        $label = $info['label'];
                        $value = $info['value'];
                        //$res = ['label' => $label, 'value' => $value];
                        $res = $this->call("procedCreate", "'$data->table'", "'$label', \"$value\"");
                    }
                } else {
                    if (isset($data->info->photo)) {
                        $data->info->photo = $this->createImage($data->info->photo, "images/$data->table/"); 
                    }
                    $info = $this->getInfo($data->info, 2);
                    $label = $info['label'];
                    $value = $info['value'];
                    //$res = ['label' => $label, 'value' => $value];
                    $res = $this->call("procedCreate", "'$data->table'", "'$label', \"$value\"");
                }
                break;
            case 'actualizar':
                $info = $this->getInfo($data->info, 3);
                $set = $info['set'];
                $where = $info['where'];
                $res = $this->call("procedUpdate", "'$data->table'", "\"$set\", \"$where\"");
                break;
            case 'eliminar':
                $info = $this->getInfo($data->info, 4);
                $where = $info['where'];
                $res = $this->call("procedDelete", "'$data->table'", "\"$where\"");
                break;
            default:
                $res = ["error" => "No ha seleccionado una opcion correcta"];
                break;
        }

        return json_encode($res);
    }

    public function insert()
    {
        $req = json_decode($this->request->getBody());

        $data = $req->data;

        return json_encode($this->getInfo($data->info, 2));
    }


    public function getInfo($info, $type)
    {
        if ($type == 1) {
            $select = "";
            $where = "";
            foreach ($info->campos as $value) {
                $select .= $select == '' ? '' : ',';
                $select .= "'$value', $value";
            }
            if (isset($info->additional)) {
                $where = " where ";
                foreach ($info->additional as $key => $value) {
                    $where .= $where == ' where ' ? '' : ' and ';
                    if (gettype($value) == 'string') {
                        $where .= "$key like '%" . $value . "%'";
                    } else {
                        $where .= "$key = $value";
                    }
                }
            }
            return ["select" => $select, "where" => $where];
        }
        if ($type == 2) {
            $index = '';
            $data = '';
            foreach ($info as $key => $value) {
                $index .= $index == '' ? '' : ',';
                $data .= $data == '' ? '' : ',';
                $index .= $key;
                if (gettype($value) == 'string') {
                    $data .= "'" . $value . "'";
                } else if($value == null) {
                    $data .= 'null';
                } else {
                    $data .= $value;
                }
            }
            return ["label" => $index, "value" => $data];
        }

        if ($type == 3) {
            $where = '';
            $data = '';
            foreach ($info as $key => $value) {
                if ($key != 'additional') {
                    $data .= $data == '' ? '' : ',';
                    if (gettype($value) == 'string') {
                        $data .= "$key = '" . $value . "'";
                    } else {
                        $data .= "$key = $value";
                    }
                } else {
                    $where = " where ";
                    foreach ($value as $key1 => $value1) {
                        $where .= $where == ' where ' ? '' : ' and ';
                        if (gettype($value1) == 'string') {
                            $where .= "$key1 = '" . $value1 . "'";
                        } else {
                            $where .= "$key1 = $value1";
                        }
                    }
                }
            }
            return ["set" => $data, "where" => $where];
        }

        if ($type == 4) {
            $where = '';
            if (isset($info->additional)) {
                $where = " where ";
                foreach ($info->additional as $key1 => $value1) {
                    $where .= $where == ' where ' ? '' : ' and ';
                    if (gettype($value1) == 'string') {
                        $where .= "$key1 = '" . $value1 . "'";
                    } else {
                        $where .= "$key1 = $value1";
                    }
                }
            }

            return ["where" => $where];
        }
    }

    private function call($procedure, $table, $data)
    {
        try {
            //code...
            if ($table == '') {
                $res = $this->db->query("call $procedure($data)")->getResult();
            } else {
                $aux = $this->db->query("call $procedure($table,$data)");
                $res = $aux->getResult();
                
            }
            return ($res);
        } catch (Exception $e) {
            //throw $th;
            return ["error" => $e->getMessage()];
        }
    }

    public function custom() {
        $req = json_decode($this->request->getBody());

        $data = $req->data;

        switch ($data->action) {
            case 'products':
                $res1 = $this->call("getProducts", "", "");
                $res = json_decode($res1[0]->result);

                break;
            case 'login':
                $email = $data->info->email;
                $pass = $data->info->password;
                $res1 = $this->call("login", "", "'$email','$pass'");
                $res = json_decode($res1[0]->result);
                break;
            case 'services':
                $client = $data->info->client;
                $type_service = $data->info->type_service;
                $res1 = $this->call("procedServicebyTypeClient", "", "'$client','$type_service'");
                $res = json_decode($res1[0]->result);
                break;
            case 'randomProduct':
                $num = $data->info->num;
                $res1 = $this->call("getRandomProducts", "", "'$num'");
                $res = json_decode($res1[0]->result);
                break;
            default:
                $res = ["error" => "No ha seleccionado una opcion correcta"];
                break;
        }

        return json_encode($res);
    }

    private function createImage($base64, $route)
    {
        $res = "";
        $aux = explode(";base64,", $base64);
        $type = explode("image/", $aux[0])[1];
        $name = $this->generateRandomString();
        $img = imagecreatefromstring(base64_decode($aux[1]));
        if ($img != false) {
            if (!file_exists($route)) {
                mkdir($route, 0777, true);
            }
            $res = $route.$name.'.'.$type;
            imagejpeg($img, $res);
        }
        return $res;
    }

    private function getAdditional($info) {
        $where = " where ";
                foreach ($info->additional as $key => $value) {
                    $where .= $where == ' where ' ? '' : ' and ';
                    if (gettype($value) == 'string') {
                        $where .= "$key like '%" . $value . "%'";
                    } else {
                        $where .= "$key = $value";
                    }
                }
        return $where;
    }

    private function generateRandomString($length = 30) {
        return substr(str_shuffle(str_repeat($x='0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ', ceil($length/strlen($x)) )),1,$length);
    }

    private function log() {
        /* $myfile = fopen("file_name.txt", "w") or die("Unable to open file!");
        write_file('file_name.txt', $txt);
        $txt = " Php.\n";
        fwrite($myfile, $txt);
        fclose($myfile); */
        $txt = "Hello world\n";
        $myfile = file_put_contents('logs.txt', $txt.PHP_EOL , FILE_APPEND | LOCK_EX);
    }

    
}
